namespace iupglcontrols


include std/dll.e
include std/machine.e

atom iupglcontrols = open_dll({ "iupglcontrols.dll", "libiupglcontrols.so", "libiupglcontrols.dylib" })


public constant -- function delcarations
	xIupGLControlsOpen                = define_c_func( iupglcontrols, "+IupGLControlsOpen", {}, C_INT ),
	xIupGLCanvasBox                   = define_c_func( iupglcontrols, "+IupGLCanvasBoxv", {C_POINTER}, C_POINTER ),
	xIupGLSubCanvas                   = define_c_func( iupglcontrols, "+IupGLSubCanvas", {}, C_POINTER ),
	xIupGLLabel                       = define_c_func( iupglcontrols, "+IupGLLabel", {C_POINTER}, C_POINTER ),
	xIupGLSeparator                   = define_c_func( iupglcontrols, "+IupGLSeparator", {}, C_POINTER ),
	xIupGLButton                      = define_c_func( iupglcontrols, "+IupGLButton", {C_POINTER}, C_POINTER ),
	xIupGLToggle                      = define_c_func( iupglcontrols, "+IupGLToggle", {C_POINTER}, C_POINTER ),
	xIupGLLink                        = define_c_func( iupglcontrols, "+IupGLLink", {C_POINTER,C_POINTER}, C_POINTER ),
	xIupGLProgressBar                 = define_c_func( iupglcontrols, "+IupGLProgressBar", {}, C_POINTER ),
	xIupGLVal                         = define_c_func( iupglcontrols, "+IupGLVal", {}, C_POINTER ),
	xIupGLFrame                       = define_c_func( iupglcontrols, "+IupGLFrame", {C_POINTER}, C_POINTER ),
	xIupGLExpander                    = define_c_func( iupglcontrols, "+IupGLExpander", {C_POINTER}, C_POINTER ),
	xIupGLScrollBox                   = define_c_func( iupglcontrols, "+IupGLScrollBox", {C_POINTER}, C_POINTER ),
	xIupGLSizeBox                     = define_c_func( iupglcontrols, "+IupGLSizeBox", {C_POINTER}, C_POINTER ),
$

--int IupGLControlsOpen(void);
public function IupGLControlsOpen()
	atom result = c_func( xIupGLControlsOpen, {} )
	return result
end function

--Ihandle* IupGLCanvasBoxv(Ihandle** children);
public function IupGLCanvasBox(sequence children = {})
	atom p_children = allocate_pointer_array(children)
	atom result = c_func( xIupGLCanvasBox, {p_children} )
	free(p_children)
	return result
end function

--Ihandle* IupGLSubCanvas(void);
public function IupGLSubCanvas()
	atom result = c_func( xIupGLSubCanvas, {} )
	return result
end function

--Ihandle* IupGLLabel(const char* title);
public function IupGLLabel(object title = NULL)
	if sequence(title) then title = allocate_string(title) end if
	atom result = c_func( xIupGLLabel, {title} )
	return result
end function

--Ihandle* IupGLSeparator(void);
public function IupGLSeparator()
	atom result = c_func( xIupGLSeparator, {} )
	return result
end function

--Ihandle* IupGLButton(const char* title);
public function IupGLButton(object title = NULL)
	if sequence(title) then title = allocate_string(title) end if
	atom result = c_func( xIupGLButton, {title} )
	return result
end function

--Ihandle* IupGLToggle(const char* title);
public function IupGLToggle(object title = NULL)
	if sequence(title) then title = allocate_string(title) end if
	atom result = c_func( xIupGLToggle, {title} )
	return result
end function

--Ihandle* IupGLLink(const char *url, const char * title);
public function IupGLLink(object url = NULL, atom title)
	if sequence(url) then url = allocate_string(url) end if
	atom result = c_func( xIupGLLink, {url,title} )
	return result
end function

--Ihandle* IupGLProgressBar(void);
public function IupGLProgressBar()
	atom result = c_func( xIupGLProgressBar, {} )
	return result
end function

--Ihandle* IupGLVal(void);
public function IupGLVal()
	atom result = c_func( xIupGLVal, {} )
	return result
end function

--Ihandle* IupGLFrame(Ihandle* child);
public function IupGLFrame(atom child)
	atom result = c_func( xIupGLFrame, {child} )
	return result
end function

--Ihandle* IupGLExpander(Ihandle* child);
public function IupGLExpander(atom child)
	atom result = c_func( xIupGLExpander, {child} )
	return result
end function

--Ihandle* IupGLScrollBox(Ihandle* child);
public function IupGLScrollBox(atom child)
	atom result = c_func( xIupGLScrollBox, {child} )
	return result
end function

--Ihandle* IupGLSizeBox(Ihandle* child);
public function IupGLSizeBox(atom child)
	atom result = c_func( xIupGLSizeBox, {child} )
	return result
end function


